Index: /trunk/sources/HeuristicLab.Data/3.3/StringMatrix.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data/3.3/StringMatrix.cs	(revision 3053)
+++ /trunk/sources/HeuristicLab.Data/3.3/StringMatrix.cs	(revision 3054)
@@ -31,37 +31,37 @@
   [Creatable("Test")]
   [StorableClass]
-  public sealed class StringMatrix : Item, IEnumerable, IStringConvertibleMatrix {
+  public class StringMatrix : Item, IEnumerable, IStringConvertibleMatrix {
     [Storable]
-    private string[,] array;
+    protected string[,] matrix;
 
-    public int Rows {
-      get { return array.GetLength(0); }
-      private set {
+    public virtual int Rows {
+      get { return matrix.GetLength(0); }
+      protected set {
         if (value != Rows) {
-          string[,] newArray = new string[value, Columns];
-          Array.Copy(array, newArray, Math.Min(value * Columns, array.Length));
-          array = newArray;
+          string[,] newMatrix = new string[value, Columns];
+          Array.Copy(matrix, newMatrix, Math.Min(value * Columns, matrix.Length));
+          matrix = newMatrix;
           OnReset();
         }
       }
     }
-    public int Columns {
-      get { return array.GetLength(1); }
-      private set {
+    public virtual int Columns {
+      get { return matrix.GetLength(1); }
+      protected set {
         if (value != Columns) {
-          string[,] newArray = new string[Rows, value];
+          string[,] newMatrix = new string[Rows, value];
           for (int i = 0; i < Rows; i++)
-            Array.Copy(array, i * Columns, newArray, i * value, Math.Min(value, Columns));
-          array = newArray;
+            Array.Copy(matrix, i * Columns, newMatrix, i * value, Math.Min(value, Columns));
+          matrix = newMatrix;
           OnReset();
         }
       }
     }
-    public string this[int rowIndex, int columnIndex] {
-      get { return array[rowIndex, columnIndex]; }
+    public virtual string this[int rowIndex, int columnIndex] {
+      get { return matrix[rowIndex, columnIndex]; }
       set {
-        if (value != array[rowIndex, columnIndex]) {
-          if ((value != null) || (array[rowIndex, columnIndex] != string.Empty)) {
-            array[rowIndex, columnIndex] = value != null ? value : string.Empty;
+        if (value != matrix[rowIndex, columnIndex]) {
+          if ((value != null) || (matrix[rowIndex, columnIndex] != string.Empty)) {
+            matrix[rowIndex, columnIndex] = value != null ? value : string.Empty;
             OnItemChanged(rowIndex, columnIndex);
           }
@@ -71,29 +71,26 @@
 
     public StringMatrix() {
-      array = new string[0, 0];
+      matrix = new string[0, 0];
     }
     public StringMatrix(int rows, int columns) {
-      array = new string[rows, columns];
-      for (int i = 0; i < array.GetLength(0); i++) {
-        for (int j = 0; j < array.GetLength(1); j++)
-          array[i, j] = string.Empty;
+      matrix = new string[rows, columns];
+      for (int i = 0; i < matrix.GetLength(0); i++) {
+        for (int j = 0; j < matrix.GetLength(1); j++)
+          matrix[i, j] = string.Empty;
       }
     }
     public StringMatrix(string[,] elements) {
       if (elements == null) throw new ArgumentNullException();
-      array = new string[elements.GetLength(0), elements.GetLength(1)];
-      for (int i = 0; i < array.GetLength(0); i++) {
-        for (int j = 0; j < array.GetLength(1); j++)
-          array[i, j] = elements[i, j] == null ? string.Empty : elements[i, j];
+      matrix = new string[elements.GetLength(0), elements.GetLength(1)];
+      for (int i = 0; i < matrix.GetLength(0); i++) {
+        for (int j = 0; j < matrix.GetLength(1); j++)
+          matrix[i, j] = elements[i, j] == null ? string.Empty : elements[i, j];
       }
-    }
-    private StringMatrix(StringMatrix elements) {
-      if (elements == null) throw new ArgumentNullException();
-      array = (string[,])elements.array.Clone();
     }
 
     public override IDeepCloneable Clone(Cloner cloner) {
-      StringMatrix clone = new StringMatrix(this);
+      StringMatrix clone = new StringMatrix();
       cloner.RegisterClonedObject(this, clone);
+      clone.matrix = (string[,])matrix.Clone();
       return clone;
     }
@@ -102,9 +99,9 @@
       StringBuilder sb = new StringBuilder();
       sb.Append("[");
-      if (array.Length > 0) {
+      if (matrix.Length > 0) {
         for (int i = 0; i < Rows; i++) {
-          sb.Append("[").Append(array[i, 0]);
+          sb.Append("[").Append(matrix[i, 0]);
           for (int j = 1; j < Columns; j++)
-            sb.Append(";").Append(array[i, j]);
+            sb.Append(";").Append(matrix[i, j]);
           sb.Append("]");
         }
@@ -114,6 +111,40 @@
     }
 
-    public IEnumerator GetEnumerator() {
-      return array.GetEnumerator();
+    public virtual IEnumerator GetEnumerator() {
+      return matrix.GetEnumerator();
+    }
+
+    protected virtual bool Validate(string value, out string errorMessage) {
+      if (value == null) {
+        errorMessage = "Invalid Value (string must not be null)";
+        return false;
+      } else {
+        errorMessage = string.Empty;
+        return true;
+      }
+    }
+    protected virtual string GetValue(int rowIndex, int columIndex) {
+      return this[rowIndex, columIndex];
+    }
+    protected virtual bool SetValue(string value, int rowIndex, int columnIndex) {
+      if (value != null) {
+        this[rowIndex, columnIndex] = value;
+        return true;
+      } else {
+        return false;
+      }
+    }
+
+    public event EventHandler<EventArgs<int, int>> ItemChanged;
+    protected virtual void OnItemChanged(int rowIndex, int columnIndex) {
+      if (ItemChanged != null)
+        ItemChanged(this, new EventArgs<int, int>(rowIndex, columnIndex));
+      OnToStringChanged();
+    }
+    public event EventHandler Reset;
+    protected virtual void OnReset() {
+      if (Reset != null)
+        Reset(this, EventArgs.Empty);
+      OnToStringChanged();
     }
 
@@ -127,36 +158,12 @@
       set { Columns = value; }
     }
-
     bool IStringConvertibleMatrix.Validate(string value, out string errorMessage) {
-      if (value == null) {
-        errorMessage = "Invalid Value (string must not be null)";
-        return false;
-      } else {
-        errorMessage = string.Empty;
-        return true;
-      }
+      return Validate(value, out errorMessage);
     }
     string IStringConvertibleMatrix.GetValue(int rowIndex, int columIndex) {
-      return this[rowIndex, columIndex];
+      return GetValue(rowIndex, columIndex);
     }
     bool IStringConvertibleMatrix.SetValue(string value, int rowIndex, int columnIndex) {
-      if (value != null) {
-        this[rowIndex, columnIndex] = value;
-        return true;
-      } else {
-        return false;
-      }
-    }
-    public event EventHandler<EventArgs<int, int>> ItemChanged;
-    private void OnItemChanged(int rowIndex, int columnIndex) {
-      if (ItemChanged != null)
-        ItemChanged(this, new EventArgs<int, int>(rowIndex, columnIndex));
-      OnToStringChanged();
-    }
-    public event EventHandler Reset;
-    private void OnReset() {
-      if (Reset != null)
-        Reset(this, EventArgs.Empty);
-      OnToStringChanged();
+      return SetValue(value, rowIndex, columnIndex);
     }
     #endregion
Index: /trunk/sources/HeuristicLab.Data/3.3/StringValue.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data/3.3/StringValue.cs	(revision 3053)
+++ /trunk/sources/HeuristicLab.Data/3.3/StringValue.cs	(revision 3054)
@@ -28,8 +28,8 @@
   [Creatable("Test")]
   [StorableClass]
-  public sealed class StringValue : Item, IComparable, IStringConvertibleValue {
+  public class StringValue : Item, IComparable, IStringConvertibleValue {
     [Storable]
-    private string value;
-    public string Value {
+    protected string value;
+    public virtual string Value {
       get { return value; }
       set {
@@ -51,5 +51,5 @@
 
     public override IDeepCloneable Clone(Cloner cloner) {
-      StringValue clone = new StringValue(Value);
+      StringValue clone = new StringValue(value);
       cloner.RegisterClonedObject(this, clone);
       return clone;
@@ -60,5 +60,5 @@
     }
 
-    public int CompareTo(object obj) {
+    public virtual int CompareTo(object obj) {
       StringValue other = obj as StringValue;
       if (other != null)
@@ -69,5 +69,5 @@
 
     public event EventHandler ValueChanged;
-    private void OnValueChanged() {
+    protected virtual void OnValueChanged() {
       if (ValueChanged != null)
         ValueChanged(this, EventArgs.Empty);
@@ -75,6 +75,5 @@
     }
 
-    #region IStringConvertibleValue Members
-    bool IStringConvertibleValue.Validate(string value, out string errorMessage) {
+    protected virtual bool Validate(string value, out string errorMessage) {
       if (value == null) {
         errorMessage = "Invalid Value (string must not be null)";
@@ -85,8 +84,8 @@
       }
     }
-    string IStringConvertibleValue.GetValue() {
+    protected virtual string GetValue() {
       return Value;
     }
-    bool IStringConvertibleValue.SetValue(string value) {
+    protected virtual bool SetValue(string value) {
       if (value != null) {
         Value = value;
@@ -96,4 +95,15 @@
       }
     }
+
+    #region IStringConvertibleValue Members
+    bool IStringConvertibleValue.Validate(string value, out string errorMessage) {
+      return Validate(value, out errorMessage);
+    }
+    string IStringConvertibleValue.GetValue() {
+      return GetValue();
+    }
+    bool IStringConvertibleValue.SetValue(string value) {
+      return SetValue(value);
+    }
     #endregion
   }
Index: /trunk/sources/HeuristicLab.Data/3.3/TimeSpanValue.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data/3.3/TimeSpanValue.cs	(revision 3053)
+++ /trunk/sources/HeuristicLab.Data/3.3/TimeSpanValue.cs	(revision 3054)
@@ -29,15 +29,15 @@
   [Creatable("Test")]
   [StorableClass]
-  public sealed class TimeSpanValue : ValueTypeValue<TimeSpan>, IComparable, IStringConvertibleValue {
+  public class TimeSpanValue : ValueTypeValue<TimeSpan>, IComparable, IStringConvertibleValue {
     public TimeSpanValue() : base() { }
     public TimeSpanValue(TimeSpan value) : base(value) { }
 
     public override IDeepCloneable Clone(Cloner cloner) {
-      TimeSpanValue clone = new TimeSpanValue(Value);
+      TimeSpanValue clone = new TimeSpanValue(value);
       cloner.RegisterClonedObject(this, clone);
       return clone;
     }
 
-    public int CompareTo(object obj) {
+    public virtual int CompareTo(object obj) {
       TimeSpanValue other = obj as TimeSpanValue;
       if (other != null)
@@ -47,6 +47,5 @@
     }
 
-    #region IStringConvertibleValue Members
-    bool IStringConvertibleValue.Validate(string value, out string errorMessage) {
+    protected virtual bool Validate(string value, out string errorMessage) {
       TimeSpan val;
       bool valid = TimeSpan.TryParse(value, out val);
@@ -61,8 +60,8 @@
       return valid;
     }
-    string IStringConvertibleValue.GetValue() {
+    protected virtual string GetValue() {
       return Value.ToString();
     }
-    bool IStringConvertibleValue.SetValue(string value) {
+    protected virtual bool SetValue(string value) {
       TimeSpan val;
       if (TimeSpan.TryParse(value, out val)) {
@@ -73,4 +72,15 @@
       }
     }
+
+    #region IStringConvertibleValue Members
+    bool IStringConvertibleValue.Validate(string value, out string errorMessage) {
+      return Validate(value, out errorMessage);
+    }
+    string IStringConvertibleValue.GetValue() {
+      return GetValue();
+    }
+    bool IStringConvertibleValue.SetValue(string value) {
+      return SetValue(value);
+    }
     #endregion
   }
Index: /trunk/sources/HeuristicLab.Data/3.3/ValueTypeArray.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data/3.3/ValueTypeArray.cs	(revision 3053)
+++ /trunk/sources/HeuristicLab.Data/3.3/ValueTypeArray.cs	(revision 3054)
@@ -28,11 +28,11 @@
 
 namespace HeuristicLab.Data {
-  [Item("ValueTypeArray<T>", "A base class for representing arrays of value types.")]
+  [Item("ValueTypeArray<T>", "An abstract base class for representing arrays of value types.")]
   [StorableClass]
-  public class ValueTypeArray<T> : Item, IEnumerable where T : struct {
+  public abstract class ValueTypeArray<T> : Item, IEnumerable where T : struct {
     [Storable]
-    private T[] array;
+    protected T[] array;
 
-    public int Length {
+    public virtual int Length {
       get { return array.Length; }
       protected set {
@@ -43,5 +43,5 @@
       }
     }
-    public T this[int index] {
+    public virtual T this[int index] {
       get { return array[index]; }
       set {
@@ -53,17 +53,13 @@
     }
 
-    public ValueTypeArray() {
+    protected ValueTypeArray() {
       array = new T[0];
     }
-    public ValueTypeArray(int length) {
+    protected ValueTypeArray(int length) {
       array = new T[length];
     }
-    public ValueTypeArray(T[] elements) {
+    protected ValueTypeArray(T[] elements) {
       if (elements == null) throw new ArgumentNullException();
       array = (T[])elements.Clone();
-    }
-    protected ValueTypeArray(ValueTypeArray<T> elements) {
-      if (elements == null) throw new ArgumentNullException();
-      array = (T[])elements.array.Clone();
     }
 
@@ -86,10 +82,10 @@
     }
 
-    public IEnumerator GetEnumerator() {
+    public virtual IEnumerator GetEnumerator() {
       return array.GetEnumerator();
     }
 
     public event EventHandler<EventArgs<int>> ItemChanged;
-    private void OnItemChanged(int index) {
+    protected virtual void OnItemChanged(int index) {
       if (ItemChanged != null)
         ItemChanged(this, new EventArgs<int>(index));
@@ -97,5 +93,5 @@
     }
     public event EventHandler Reset;
-    private void OnReset() {
+    protected virtual void OnReset() {
       if (Reset != null)
         Reset(this, EventArgs.Empty);
Index: /trunk/sources/HeuristicLab.Data/3.3/ValueTypeMatrix.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data/3.3/ValueTypeMatrix.cs	(revision 3053)
+++ /trunk/sources/HeuristicLab.Data/3.3/ValueTypeMatrix.cs	(revision 3054)
@@ -28,38 +28,38 @@
 
 namespace HeuristicLab.Data {
-  [Item("ValueTypeMatrix<T>", "A base class for representing matrices of value types.")]
+  [Item("ValueTypeMatrix<T>", "An abstract base class for representing matrices of value types.")]
   [StorableClass]
-  public class ValueTypeMatrix<T> : Item, IEnumerable where T : struct {
+  public abstract class ValueTypeMatrix<T> : Item, IEnumerable where T : struct {
     [Storable]
-    private T[,] array;
+    protected T[,] matrix;
 
-    public int Rows {
-      get { return array.GetLength(0); }
+    public virtual int Rows {
+      get { return matrix.GetLength(0); }
       protected set {
         if (value != Rows) {
           T[,] newArray = new T[value, Columns];
-          Array.Copy(array, newArray, Math.Min(value * Columns, array.Length));
-          array = newArray;
+          Array.Copy(matrix, newArray, Math.Min(value * Columns, matrix.Length));
+          matrix = newArray;
           OnReset();
         }
       }
     }
-    public int Columns {
-      get { return array.GetLength(1); }
+    public virtual int Columns {
+      get { return matrix.GetLength(1); }
       protected set {
         if (value != Columns) {
           T[,] newArray = new T[Rows, value];
           for (int i = 0; i < Rows; i++)
-            Array.Copy(array, i * Columns, newArray, i * value, Math.Min(value, Columns));
-          array = newArray;
+            Array.Copy(matrix, i * Columns, newArray, i * value, Math.Min(value, Columns));
+          matrix = newArray;
           OnReset();
         }
       }
     }
-    public T this[int rowIndex, int columnIndex] {
-      get { return array[rowIndex, columnIndex]; }
+    public virtual T this[int rowIndex, int columnIndex] {
+      get { return matrix[rowIndex, columnIndex]; }
       set {
-        if (!value.Equals(array[rowIndex, columnIndex])) {
-          array[rowIndex, columnIndex] = value;
+        if (!value.Equals(matrix[rowIndex, columnIndex])) {
+          matrix[rowIndex, columnIndex] = value;
           OnItemChanged(rowIndex, columnIndex);
         }
@@ -67,22 +67,18 @@
     }
 
-    public ValueTypeMatrix() {
-      array = new T[0, 0];
+    protected ValueTypeMatrix() {
+      matrix = new T[0, 0];
     }
-    public ValueTypeMatrix(int rows, int columns) {
-      array = new T[rows, columns];
+    protected ValueTypeMatrix(int rows, int columns) {
+      matrix = new T[rows, columns];
     }
-    public ValueTypeMatrix(T[,] elements) {
+    protected ValueTypeMatrix(T[,] elements) {
       if (elements == null) throw new ArgumentNullException();
-      array = (T[,])elements.Clone();
-    }
-    protected ValueTypeMatrix(ValueTypeMatrix<T> elements) {
-      if (elements == null) throw new ArgumentNullException();
-      array = (T[,])elements.array.Clone();
+      matrix = (T[,])elements.Clone();
     }
 
     public override IDeepCloneable Clone(Cloner cloner) {
       ValueTypeMatrix<T> clone = (ValueTypeMatrix<T>)base.Clone(cloner);
-      clone.array = (T[,])array.Clone();
+      clone.matrix = (T[,])matrix.Clone();
       return clone;
     }
@@ -91,9 +87,9 @@
       StringBuilder sb = new StringBuilder();
       sb.Append("[");
-      if (array.Length > 0) {
+      if (matrix.Length > 0) {
         for (int i = 0; i < Rows; i++) {
-          sb.Append("[").Append(array[i, 0].ToString());
+          sb.Append("[").Append(matrix[i, 0].ToString());
           for (int j = 1; j < Columns; j++)
-            sb.Append(";").Append(array[i, j].ToString());
+            sb.Append(";").Append(matrix[i, j].ToString());
           sb.Append("]");
         }
@@ -103,10 +99,10 @@
     }
 
-    public IEnumerator GetEnumerator() {
-      return array.GetEnumerator();
+    public virtual IEnumerator GetEnumerator() {
+      return matrix.GetEnumerator();
     }
 
     public event EventHandler<EventArgs<int, int>> ItemChanged;
-    private void OnItemChanged(int rowIndex, int columnIndex) {
+    protected virtual void OnItemChanged(int rowIndex, int columnIndex) {
       if (ItemChanged != null)
         ItemChanged(this, new EventArgs<int, int>(rowIndex, columnIndex));
@@ -114,5 +110,5 @@
     }
     public event EventHandler Reset;
-    private void OnReset() {
+    protected virtual void OnReset() {
       if (Reset != null)
         Reset(this, EventArgs.Empty);
Index: /trunk/sources/HeuristicLab.Data/3.3/ValueTypeValue.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data/3.3/ValueTypeValue.cs	(revision 3053)
+++ /trunk/sources/HeuristicLab.Data/3.3/ValueTypeValue.cs	(revision 3054)
@@ -25,10 +25,10 @@
 
 namespace HeuristicLab.Data {
-  [Item("ValueTypeValue<T>", "A base class for representing value types.")]
+  [Item("ValueTypeValue<T>", "An abstract base class for representing values of value types.")]
   [StorableClass]
-  public class ValueTypeValue<T> : Item where T : struct {
+  public abstract class ValueTypeValue<T> : Item where T : struct {
     [Storable]
-    private T value;
-    public T Value {
+    protected T value;
+    public virtual T Value {
       get { return value; }
       set {
@@ -40,8 +40,8 @@
     }
 
-    public ValueTypeValue() {
+    protected ValueTypeValue() {
       this.value = default(T);
     }
-    public ValueTypeValue(T value) {
+    protected ValueTypeValue(T value) {
       this.value = value;
     }
Index: /trunk/sources/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/BinaryVector.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/BinaryVector.cs	(revision 3054)
+++ /trunk/sources/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/BinaryVector.cs	(revision 3054)
@@ -0,0 +1,61 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.BinaryVectorEncoding {
+  [StorableClass]
+  [Item("BinaryVector", "Represents a vector of binary values.")]
+  [Creatable("Test")]
+  public class BinaryVector : BoolArray {
+    public BinaryVector() : base() { }
+    public BinaryVector(int length) : base(length) { }
+    public BinaryVector(int length, IRandom random)
+      : this(length) {
+      Randomize(random);
+    }
+    public BinaryVector(bool[] elements) : base(elements) { }
+    public BinaryVector(BoolArray elements)
+      : this(elements.Length) {
+      for (int i = 0; i < array.Length; i++)
+        array[i] = elements[i];
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      BinaryVector clone = new BinaryVector(array);
+      cloner.RegisterClonedObject(this, clone);
+      return clone;
+    }
+
+    public virtual void Randomize(IRandom random, int startIndex, int length) {
+      if (length > 0) {
+        for (int i = 0; i < length; i++)
+          array[startIndex + i] = random.Next(2) == 0;
+        OnReset();
+      }
+    }
+    public void Randomize(IRandom random) {
+      Randomize(random, 0, Length);
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/HeuristicLab.Encodings.BinaryVectorEncoding-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/HeuristicLab.Encodings.BinaryVectorEncoding-3.3.csproj	(revision 3053)
+++ /trunk/sources/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/HeuristicLab.Encodings.BinaryVectorEncoding-3.3.csproj	(revision 3054)
@@ -86,4 +86,5 @@
   <ItemGroup>
     <Compile Include="HeuristicLabEncodingsBinaryVectorEncodingPlugin.cs" />
+    <Compile Include="BinaryVector.cs" />
     <Compile Include="Interfaces\IBinaryVectorCreator.cs" />
     <Compile Include="Interfaces\IBinaryVectorCrossover.cs" />
Index: /trunk/sources/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/HeuristicLab.Encodings.IntegerVectorEncoding-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/HeuristicLab.Encodings.IntegerVectorEncoding-3.3.csproj	(revision 3053)
+++ /trunk/sources/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/HeuristicLab.Encodings.IntegerVectorEncoding-3.3.csproj	(revision 3054)
@@ -96,4 +96,5 @@
       <SubType>Code</SubType>
     </Compile>
+    <Compile Include="IntegerVector.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
     <Compile Include="IntVectorCreator.cs" />
Index: /trunk/sources/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/IntegerVector.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/IntegerVector.cs	(revision 3054)
+++ /trunk/sources/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/IntegerVector.cs	(revision 3054)
@@ -0,0 +1,61 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.IntegerVectorEncoding {
+  [StorableClass]
+  [Item("IntegerVector", "Represents a vector of integer values.")]
+  [Creatable("Test")]
+  public class IntegerVector : IntArray {
+    public IntegerVector() : base() { }
+    public IntegerVector(int length) : base(length) { }
+    public IntegerVector(int length, IRandom random, int min, int max)
+      : this(length) {
+      Randomize(random, min, max);
+    }
+    public IntegerVector(int[] elements) : base(elements) { }
+    public IntegerVector(IntArray elements)
+      : this(elements.Length) {
+      for (int i = 0; i < array.Length; i++)
+        array[i] = elements[i];
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      IntegerVector clone = new IntegerVector(array);
+      cloner.RegisterClonedObject(this, clone);
+      return clone;
+    }
+
+    public virtual void Randomize(IRandom random, int startIndex, int length, int min, int max) {
+      if (length > 0) {
+        for (int i = 0; i < length; i++)
+          array[startIndex + i] = random.Next(min, max);
+        OnReset();
+      }
+    }
+    public void Randomize(IRandom random, int min, int max) {
+      Randomize(random, 0, Length, min, max);
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Encodings.PermutationEncoding/3.3/Permutation.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.PermutationEncoding/3.3/Permutation.cs	(revision 3053)
+++ /trunk/sources/HeuristicLab.Encodings.PermutationEncoding/3.3/Permutation.cs	(revision 3054)
@@ -20,7 +20,4 @@
 #endregion
 
-using System;
-using System.Text;
-using HeuristicLab.Common;
 using HeuristicLab.Core;
 using HeuristicLab.Data;
@@ -31,5 +28,5 @@
   [Item("Permutation", "Represents a permutation of integer values.")]
   [Creatable("Test")]
-  public sealed class Permutation : ValueTypeArray<int>, IStringConvertibleArray {
+  public class Permutation : IntArray {
     public Permutation() : base() { }
     public Permutation(int length)
@@ -42,16 +39,18 @@
       Randomize(random);
     }
-    public Permutation(int[] elements)
-      : base(elements) {
+    public Permutation(int[] elements) : base(elements) { }
+    public Permutation(IntArray elements)
+      : this(elements.Length) {
+      for (int i = 0; i < array.Length; i++)
+        array[i] = elements[i];
     }
-    private Permutation(Permutation elements) : base(elements) { }
 
     public override IDeepCloneable Clone(Cloner cloner) {
-      Permutation clone = new Permutation(this);
+      Permutation clone = new Permutation(array);
       cloner.RegisterClonedObject(this, clone);
       return clone;
     }
 
-    public bool Validate() {
+    public virtual bool Validate() {
       bool[] values = new bool[Length];
       int value;
@@ -68,15 +67,19 @@
     }
 
-    public void Randomize(IRandom random, int startIndex, int length) {  // Knuth shuffle
-      int index1, index2;
-      int val;
-      for (int i = length - 1; i > 0; i--) {
-        index1 = startIndex + i;
-        index2 = startIndex + random.Next(i + 1);
-        if (index1 != index2) {
-          val = this[index1];
-          this[index1] = this[index2];
-          this[index2] = val;
+    public virtual void Randomize(IRandom random, int startIndex, int length) {
+      if (length > 1) {
+        // Knuth shuffle
+        int index1, index2;
+        int val;
+        for (int i = length - 1; i > 0; i--) {
+          index1 = startIndex + i;
+          index2 = startIndex + random.Next(i + 1);
+          if (index1 != index2) {
+            val = array[index1];
+            array[index1] = array[index2];
+            array[index2] = val;
+          }
         }
+        OnReset();
       }
     }
@@ -85,42 +88,9 @@
     }
 
-    public int GetCircular(int position) {
+    public virtual int GetCircular(int position) {
       if (position >= Length) position = position % Length;
       while (position < 0) position += Length;
       return this[position];
     }
-
-    #region IStringConvertibleArrayData Members
-    int IStringConvertibleArray.Length {
-      get { return Length; }
-      set { Length = value; }
-    }
-
-    bool IStringConvertibleArray.Validate(string value, out string errorMessage) {
-      int val;
-      bool valid = int.TryParse(value, out val);
-      errorMessage = string.Empty;
-      if (!valid) {
-        StringBuilder sb = new StringBuilder();
-        sb.Append("Invalid Value (Valid Value Format: \"");
-        sb.Append(FormatPatterns.GetIntFormatPattern());
-        sb.Append("\")");
-        errorMessage = sb.ToString();
-      }
-      return valid;
-    }
-    string IStringConvertibleArray.GetValue(int index) {
-      return this[index].ToString();
-    }
-    bool IStringConvertibleArray.SetValue(string value, int index) {
-      int val;
-      if (int.TryParse(value, out val)) {
-        this[index] = val;
-        return true;
-      } else {
-        return false;
-      }
-    }
-    #endregion
   }
 }
Index: /trunk/sources/HeuristicLab.Encodings.RealVectorEncoding/3.3/HeuristicLab.Encodings.RealVectorEncoding-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.RealVectorEncoding/3.3/HeuristicLab.Encodings.RealVectorEncoding-3.3.csproj	(revision 3053)
+++ /trunk/sources/HeuristicLab.Encodings.RealVectorEncoding/3.3/HeuristicLab.Encodings.RealVectorEncoding-3.3.csproj	(revision 3054)
@@ -103,4 +103,5 @@
     <Compile Include="Crossovers\UniformSomePositionsArithmeticCrossover.cs" />
     <Compile Include="HeuristicLabEncodingsRealVectorEncodingPlugin.cs" />
+    <Compile Include="RealVector.cs" />
     <Compile Include="Manipulators\BreederGeneticAlgorithmManipulator.cs" />
     <Compile Include="Manipulators\PolynomialAllPositionManipulator.cs" />
